Emd.idl
/* SPDX-License-Identifier: BSD-3-Clause */
/*
* Copyright 2010 Raritan Inc. All rights reserved.
*/
#ifndef __EMDMODEL_EMD_IDL__
#define __EMDMODEL_EMD_IDL__
#include <InternalBeeper.idl>
#include <Nameplate.idl>
#include <PeripheralDeviceManager.idl>
#include <Port.idl>
#include <SensorLogger.idl>
/**
* EMD Model interfaces
*/
module emdmodel {
interface Emd_2_2_8 {
constant int ERR_INVALID_PARAMS = 1;
/** EMD metadata */
structure MetaData {
pdumodel.Nameplate_2_0_0 nameplate; ///< %Nameplate information
string ctrlBoardSerial; ///< Main controller serial number
string hwRevision; ///< Hardware revision
string fwRevision; ///< Firmware revision
string macAddress; ///< MAC address
};
/** EMD settings */
structure Settings {
string name; ///< User-defined name
};
/** Event: EMD settings have changed */
valueobject SettingsChangedEvent extends event.UserEvent {
Settings oldSettings; ///< Settings before change
Settings newSettings; ///< Settings after change
};
/**
* Retrieve the EMD metadata.
*
* @return EMD metadata
*/
MetaData getMetaData();
/**
* Get the peripheral device manager.
*
* @return Peripheral device manager
*/
peripheral.DeviceManager_3_0_2 getPeripheralDeviceManager();
/**
* Get the built-in beeper, if there is any.
*
* @return Beeper interface
*/
hmi.InternalBeeper_2_0_1 getBeeper();
/**
* Retrieve the EMD settings.
*
* @return EMD settings
*/
Settings getSettings();
/**
* Change the EMD settings.
*
* @param settings New EMD settings
*
* @return 0 if OK
* @return ERR_INVALID_PARAMS if any parameters are invalid
*/
int setSettings(in Settings settings);
/**
* Get all feature ports of this device
*
* This returns an entry for all feature ports, no matter whether
* something is connected or not.
* A device with n feature ports will return n entries here.
*
* @return List of all Feature Ports
*/
vector<portsmodel.Port_2_0_2> getFeaturePorts();
/**
* Get all auxiliary ports of this device
*
* This returns an entry for all auxiliary ports, no matter whether
* something is connected or not.
* A device with n auxiliary ports will return n entries here.
*
* @return List of all Auxiliary Ports
*/
vector<portsmodel.Port_2_0_2> getAuxiliaryPorts();
/**
* Get the sensor logger.
*
* @return Sensor logger reference
*/
sensors.Logger_2_1_6 getSensorLogger();
};
}
#endif /* !__EMDMODEL_EMD_IDL__ */
emdmodel::Emd_2_2_8::MetaData::macAddress
string macAddress
MAC address.
Definition: Emd.idl:31
emdmodel::Emd_2_2_8::Settings::name
string name
User-defined name.
Definition: Emd.idl:36
emdmodel::Emd_2_2_8::MetaData
EMD metadata.
Definition: Emd.idl:26
emdmodel::Emd_2_2_8::MetaData::fwRevision
string fwRevision
Firmware revision.
Definition: Emd.idl:30
emdmodel::Emd_2_2_8
Definition: Emd.idl:21
emdmodel::Emd_2_2_8::MetaData::nameplate
pdumodel::Nameplate_2_0_0 nameplate
Nameplate information
Definition: Emd.idl:27
peripheral
Peripheral Devices.
Definition: PeripheralDeviceManager.idl:17
emdmodel
EMD Model interfaces.
Definition: Emd.idl:19
emdmodel::Emd_2_2_8::MetaData::ctrlBoardSerial
string ctrlBoardSerial
Main controller serial number.
Definition: Emd.idl:28
emdmodel::Emd_2_2_8::Settings
EMD settings.
Definition: Emd.idl:35
pdumodel::Nameplate_2_0_0
Component nameplate information.
Definition: Nameplate.idl:23
portsmodel
Ports.
Definition: Port.idl:15
hmi
Human Machine Interface.
Definition: ExternalBeeper.idl:14
emdmodel::Emd_2_2_8::newSettings
Settings newSettings
Settings after change.
Definition: Emd.idl:42
hmi::InternalBeeper_2_0_1
Internal beeper interface.
Definition: InternalBeeper.idl:15
sensors
Sensors Model.
Definition: AccumulatingNumericSensor.idl:13
pdumodel
PDU Model.
Definition: Ade.idl:12
sensors::Logger_2_1_6
Sensor logger interface.
Definition: SensorLogger.idl:31
portsmodel::Port_2_0_2
Port interface.
Definition: Port.idl:18
emdmodel::Emd_2_2_8::MetaData::hwRevision
string hwRevision
Hardware revision.
Definition: Emd.idl:29
peripheral::DeviceManager_3_0_2
Peripheral Device Manager.
Definition: PeripheralDeviceManager.idl:20